<template>
    <div class="wrapper">
        <div class="container-fuild">
            <div id="headTitle">
                <Logo />
                <h1 id="title" _msttexthash="48503" _msthash="2">
                    {{ i18ntext.lngText('appointment') }}
                </h1>
            </div>
        </div>
        <div class="container-fuild">
            <Header />
            <ol id="topicPath">
                <li style="margin-left: 310px">
                    <router-link to="dashbaord">
                        <a href="dashbaord">
                            <font style="vertical-align: inherit"></font>
                            <font style="vertical-align: inherit">
                                {{ i18ntext.lngText('appointment') }}
                            </font>
                        </a>
                    </router-link>
                </li>
            </ol>
            <div class="search-box">
                <div id="product">
                    <!--#contents -->
                    <div class="search-box">
                        <div class="search-box-title" id="Bars">
                            <div id="bar" style="width: 90%;gap: 0;">
                                <a >
                                    <a @click="BackToHistory()" class="btn-radius btn btn-sm"  style="color: #f8f5b4; margin-top: -2px; color: #dbdee1">
                                        <i class="fa fa-arrow-left" style="margin-top: -2px;"></i>
                                    {{ i18ntext.lngText('back') }}
                                    </a>
                                </a>
                            </div>
                            <div id="right" style="width: 10%;">
                                <a class="btn-radius bt-pn btn btn-sm" data-bs-toggle="dropdown" aria-expanded="false"
                                    style="float:right; color: #f8f5b4;margin-top: -2px;margin-right: 11px;">
                                    <i class="fas fa-plus" style="padding-right:5px;">
                                    </i>
                                    {{ i18ntext.lngText('menu') }}
                                </a>
                                <ul class="dropdown-menu">
                                    <li>
                                        <a class="dropdown-item btn btn-primary" data-bs-toggle="modal"
                                            data-bs-target="#staticboomId" tabindex="10028"><i class="fa fa-print"
                                                aria-hidden="true"></i> {{ i18ntext.lngText('print') }}</a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        <input autocomplete="off" id="search" name="search" type="hidden" value="1" />
                        <input autocomplete="off" id="search" name="search" type="hidden" value="1" />
                        <div class="box">
                            <div class="box-content">
                                <table width="100%" border="0" cellpadding="0" cellspacing="0"
                                    class="table table-striped br-table">
                                    <thead>
                                        <tr class="header-table">
                                            <th colspan="7" style="width: 55em;"><input autocomplete="off" @change="clearText('name')"
                                                    @input="getDefault()" v-model="pre_search.name" id="search"
                                                    name="search" type="search" class="text text-1"
                                                    :placeholder="i18ntext.lngText('pre_id') + ',' + i18ntext.lngText('patient_name') + ',' + i18ntext.lngText('phonenumber') + ',' + i18ntext.lngText('address')"
                                                    style="width: 100%;"></th>
                                            <th colspan="2" class="exp">
                                                <div><span><input autocomplete="off" v-model="pre_search.startDate" @change="clearText('date')"
                                                            id="search" name="search" type="date" class="text"
                                                            placeholder="Search"
                                                            style="margin-right: 0px !important;"></span><span
                                                        style="margin: 0px 10px;">To</span><span><input autocomplete="off"
                                                            @change="clearText('date')" v-model="pre_search.endDate"
                                                            id="search" name="search" type="date" class="text"
                                                            placeholder="Search"
                                                            style="margin-right: 0px !important;"></span></div>
                                            </th>
                                            <th></th>
                                            <th>
                                                <input autocomplete="off" v-model="pre_search.type" id="search" @change="clearText('type')"
                                                    name="search" type="search" class="text"
                                                    :placeholder="i18ntext.lngText('type')" style="width: 100%;">
                                            </th>
                                            <th></th>
                                            <th>
                                                <div @click="getview()" class="button type2" id="uniform-undefined">
                                                    <span><input autocomplete="off" type="button" class="type2" tabindex="10025"
                                                            value="display" style="opacity: 0; width: 54px;"><i
                                                            class="fa fa-search"></i>
                                                        {{ i18ntext.lngText('search') }}</span>
                                                </div>
                                            </th>
                                        </tr>
                                        <tr class="header-table">
                                            <th style="width:3%">{{ i18ntext.lngText('no') }}</th>
                                            <th width="10%">{{ i18ntext.lngText('name') }}</th>
                                            <th style="width:4%">{{ i18ntext.lngText('sex') }}</th>
                                            <th style="width:4%">{{ i18ntext.lngText('age') }}</th>
                                            <th style="width:4%">{{ i18ntext.lngText('weight') }}</th>
                                            <th style="width:12%">{{ i18ntext.lngText('diangosis') }}</th>
                                            <th width="7%">{{ i18ntext.lngText('phonenumber') }}</th>
                                            <th width="8%">{{ i18ntext.lngText('address') }}</th>
                                            <th style="width:5%">{{ i18ntext.lngText('appointment') }}</th>
                                            <th style="width:8%">{{ i18ntext.lngText('visitdate') }}</th>
                                            <th width="8%">{{ i18ntext.lngText('type') }}</th>
                                            <th width="15%">{{ i18ntext.lngText('remark') }}</th>
                                            <th width="7%"></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr v-for="(reg, index) in getpres.data" :key="index">
                                            <td>{{ index + 1 }}</td>
                                            <td>{{ reg.firstname }} {{ reg.lstname }}</td>
                                            <td>{{ reg.sex }}</td>
                                            <td>{{ reg.age }}</td>
                                            <td>{{ reg.width }}</td>
                                            <td>{{ reg.group_code }}</td>
                                            <td>{{ reg.phone1 }} </td>
                                            <td>
                                                {{ reg.address }} {{ reg.village }} {{ reg.commune }} {{ reg.district }}
                                                {{
                                                    reg.pro_city }}
                                            </td>
                                            <td v-if="reg.appointment_date != null">{{ formatdatetime(reg.appointment_date)
                                            }}</td>
                                            <td v-else>{{ reg.appointment_date }}</td>
                                            <td>{{ formatdatetime(reg.visit_date) }}</td>
                                            <td>{{ reg.type }}</td>
                                            <td>{{ reg.remark }}</td>
                                            <td v-if="compareDate(reg.appointment_date)" class="text-center d-flex">
                                                <div class="button type2" @click="selectItem(reg)">
                                                    <span><input autocomplete="off" type="button" value="display" class="type2"
                                                            style="opacity: 0; width: 54px" tabindex="10025" />
                                                        {{ i18ntext.lngText('select') }}</span>
                                                </div>
                                                <div class="button type2" @click="getRemoveId(reg.preid)">
                                                    <span><input autocomplete="off" type="button" value="display" class="type2"
                                                            style="opacity: 0; width: 54px"
                                                            tabindex="10025" />{{ i18ntext.lngText('remove') }}</span>
                                                </div>
                                            </td>
                                            <td v-else></td>
                                        </tr>
                                    </tbody>
                                </table>
                                <div class="box-footer-pagination">
                                    <pagination :limit="2" :data="getpres" @pagination-change-page="getview" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade ui-modal" id="staticboomId" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
        aria-labelledby="staticboomId" aria-hidden="true">
        <div class="modal-dialog" style="max-width:87% !important;">
            <div class="modal-content ui-dialog">
                <div class="ui-widget-header">
                    <h5 class="modal-title in-header" id="staticBackdropLabel"><i class="fa fa-print"
                            aria-hidden="true"></i>
                        {{ i18ntext.lngText('print') }}</h5>
                    <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
                </div>
                <div class="ui-dialog-content">
                    <div class="card">
                        <div class="card-body">
                            <div class="mt-3 print-size">
                                <div style="padding:0 50px 0 50px" id="printProduct">
                                    <div class="col-md-12">
                                        <div class="text-center">
                                            <h3 class="title-purchase">{{ i18ntext.lngText('report') }}
                                                {{ i18ntext.lngText('view_all') }}</h3>
                                        </div>
                                    </div>
                                    <div class="col-container">
                                        <div class="col1" style="width: 55%;">
                                            <p class=" p-bg font-size p-pad">{{ i18ntext.lngText('company') }}</p>
                                            <p class="p-mg info-pad"><span id="bold">{{ i18ntext.lngText('name') }} :</span>
                                                <span id="fon">{{ company.company_name }}</span></p>
                                            <p class="p-mg  info-pad"><span id="bold">{{ i18ntext.lngText('phonenumber') }}
                                                    :</span> <span id="fon">{{ company.company_Phone }}</span></p>
                                            <p class="p-mg info-pad"><span id="bold">{{ i18ntext.lngText('email') }} :</span>
                                                <span id="fon">{{ company.company_Email }}</span></p>
                                            <p class="p-mg info-pad"><span id="bold">{{ i18ntext.lngText('address') }}
                                                    :</span> <span id="fon">{{ company.company_Address }}</span></p>
                                        </div>
                                        <div class="col2">
                                            <p class="text-center p-bg font-size p-pad">{{ i18ntext.lngText('date') }}</p>
                                            <p class="text-center p-mg" id="fon">{{ dateformart }}</p>
                                            <p class="text-center p-bg font-size p-pad">{{ i18ntext.lngText('total') }}
                                                {{ i18ntext.lngText('view_all') }}</p>
                                            <p class="text-center p-mg" id="fon">{{ print.length }}</p>
                                        </div>
                                    </div>
                                    <div class="my-2 justify-content-center">
                                        <table id="pr-tb">
                                            <thead>
                                                <tr class="p-bg">
                                                    <th class="text-center" style="width:4%">{{ i18ntext.lngText('no') }}</th>
                                                    <th class="text-center">{{ i18ntext.lngText('name') }}</th>
                                                    <th class="text-center" style="width:5%">{{ i18ntext.lngText('sex') }}
                                                    </th>
                                                    <th class="text-center" style="width:5%">{{ i18ntext.lngText('age') }}
                                                    </th>
                                                    <th class="text-center" style="width:5%">{{ i18ntext.lngText('weight') }}
                                                    </th>
                                                    <th class="text-center">{{ i18ntext.lngText('phonenumber') }}</th>
                                                    <th class="text-center">{{ i18ntext.lngText('address') }}</th>
                                                    <th class="text-center">{{ i18ntext.lngText('date') }}</th>
                                                    <th class="text-center">{{ i18ntext.lngText('appointment') }}</th>
                                                    <th class="text-center">{{ i18ntext.lngText('type') }}</th>
                                                    <th class="text-center">{{ i18ntext.lngText('remark') }}</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr v-for="(reg, index) in print" :key="index">
                                                    <td>{{ index + 1 }}</td>
                                                    <td>{{ reg.firstname }} {{ reg.lstname }}</td>
                                                    <td>{{ reg.sex }}</td>
                                                    <td>{{ reg.age }}</td>
                                                    <td>{{ reg.width }}</td>
                                                    <td>{{ reg.phone1 }}</td>
                                                    <td>
                                                        {{ reg.pro_city }}
                                                    </td>
                                                    <td v-if="reg.visit_date == null">{{ reg.visit_date }}</td>
                                                    <td v-else>{{ formatdatetime(reg.visit_date) }}</td>
                                                    <td v-if="reg.appointment_date == null">{{ reg.appointment_date }}</td>
                                                    <td v-else>{{ formatdatetime(reg.appointment_date) }}</td>
                                                    <td>{{ reg.type }}</td>
                                                    <td>{{ reg.remark }}</td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </div>
                                    <hr>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <a v-print="'#printProduct'" class="btn-purchase btn-light text-capitalize border-0"
                        data-mdb-ripple-color="dark"><i class="fas fa-print text-primary"></i>
                        {{ i18ntext.lngText('print') }}</a>
                </div>
            </div>
        </div>
    </div>
    <div id="myModal" class="lskymodal">
        <div class="lskymodal-content">
            <p><i class="fa fa-check" aria-hidden="true"></i> {{ message }}</p>
        </div>
    </div>

    <div class="modal fade ui-modal" id="appointmentcreate" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
    aria-labelledby="clearconfirm" aria-hidden="true">
    <div class="modal-dialog smallpopup" id="nonbackgroundboom">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title" id="exampleModalLabel">
            <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">{{i18ntext.lngText('confirm_message')}}</span>
          </h5>
          <span class="ui-icon ui-icon-closethick btn-cancel" data-bs-dismiss="modal" aria-label="Close"></span>
        </div>
        <div class="ui-dialog-content" style="background-color: #fff">
          <div class="modal-body"><span style="color: brown; padding: auto;"> {{i18ntext.lngText('create_message')}}</span>
            </div>
          <div class="modal-footer">
            <div class="button type2" data-bs-dismiss="modal" @click="addLabo()">
              <span>{{i18ntext.lngText('labo')}}</span>
            </div>
            <div class="button type2" data-bs-dismiss="modal" @click="addPres()">
              <span>{{i18ntext.lngText('prescription')}}</span>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- modal create -->
  <div class="modal fade ui-modal" id="addnew" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
    aria-labelledby="clearconfirm" aria-hidden="true">
    <div class="modal-dialog smallpopup" id="nonbackgroundboom">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title" id="exampleModalLabel">
            <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">{{i18ntext.lngText('confirm_message')}}</span>
          </h5>
          <span class="ui-icon ui-icon-closethick btn-cancel" data-bs-dismiss="modal" aria-label="Close"></span>
        </div>
        <div class="ui-dialog-content" style="background-color: #fff">
          <div class="modal-body"><span style="color: brown; padding: auto;"> {{i18ntext.lngText('create_message')}} </span>
            </div>
          <div class="modal-footer">
            <div class="button type2" data-bs-dismiss="modal">
              <span>{{i18ntext.lngText('No')}}</span>
            </div>
            <div class="button type2" data-bs-dismiss="modal" @click="createAppoint()">
              <span>{{i18ntext.lngText('yes')}}</span>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- end -->
  <!-- remove confirm -->
  <div class="modal fade ui-modal" id="removeconfirm" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
    aria-labelledby="clearconfirm" aria-hidden="true">
    <div class="modal-dialog smallpopup" id="nonbackgroundboom">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title" id="exampleModalLabel">
            <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">{{i18ntext.lngText('confirm_message')}}</span>
          </h5>
          <span class="ui-icon ui-icon-closethick btn-cancel" data-bs-dismiss="modal" aria-label="Close"></span>
        </div>
        <div class="ui-dialog-content" style="background-color: #fff">
          <div class="modal-body"><span style=" padding: auto;">{{i18ntext.lngText('delete_message')}}</span>
            </div>
          <div class="modal-footer">
            <div  class="button type2" data-bs-dismiss="modal">
              <span>{{i18ntext.lngText('No')}}</span>
            </div>
            <div class="button type2" data-bs-dismiss="modal" @click="removeAppoint()">
              <span>{{i18ntext.lngText('yes')}}</span>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
<!-- end -->


    <Footer />
    <UserInfo />
</template>

<script>

import Header from '../Header.vue'
import axios from "axios";
import Logo from "../logo.vue"
import moment from "moment";
import pagination from "laravel-vue-pagination";
import print from "vue3-print-nb";
import Footer from "../footer.vue";
import Auth from '../../auth/Auth';
import i18n from "../../i18n/i18n";
import UserInfo from "../UserInfo.vue";
export default {
    name: "Appointment",
    components: { Header, pagination, Logo, Footer, UserInfo },
    directives: { print },
    data() {
        return {
            i18ntext: i18n,
            labo: 20,
            pre: "",
            fullname: "",
            remove_id : '',
            updateBy:{
                updated_by : Auth.user.id
            },
            message: '',
            Address: "",
            getpres: [],
            company: [],
            selectProduct: [],
            total: 0,
            form: {
                sex: "",
                preid: "",
                paid: "",
                lstname: "",
                firstname: "",
                Age: "",
                visit_date: "",
                pateinid: "",
                birstdate: "",
                remark: "",
                appointment_date: "",
                age: "",
                allergies: "",
                history_disease: "",
                bp: "",
                pr: "",
                rr: "",
                spo2: "",
                t: "",
                address: "",
                village: "",
                commune: "",
                district: "",
                pro_city: "",
                phone1: "",
                type: "",
            },
            form1: {
                id: "",
                user_name: "",
                document_no: "",
                document_type: "",
                closeshift_id: "",
                description: "",
                total_amount_usd: "",
                total_amount: "",
                change_amount: "",
                paymeny_method: "",
                change_amount_usd: "",
                type: "",
                total_receipts: "",
                total_receipt_usd: "",
                discount: "",
                curency_code: "",
                exchane_rate: "",
                statue: "",
                created_by: "",
                updated_by: "",

            },
            search: {
                pateinid: "",
                lstname: "",
                firstname: "",
                type: "",
                phone1: "",
                address: "",
                village: "",
                commune: "",
                district: "",
                pro_city: "",
                visit_date: "",
                appointment_date: "",
                remark: "",
            },
            pre_search: {
                name: '',
                startDate: '',
                endDate: '',
                type: ''
            },

            user: {},
            print: [],
            dateformart: '',
            number_page : 1,
            new_appointment:{
                preid: '',
                created_by : Auth.user.id,
                type: ''
            },
            number_page : ''
        }
    },
    mounted() {
        if(this.$route.query.page != 1){
            this.number_page = this.$route.query.page
            axios.post("/api/v1/prescription/getAllAppointment?page=" + this.number_page,this.pre_search)
                .then((response) => {
                    this.getpres = response.data.data;
                    this.total = this.getpres.length;
                    this.print = response.data.print
                });
        }else{
            this.getview();
        }
        this.getcompany()
    },
    methods: {

        compareDate(passDate){
            let date = new Date();
            let date1 =  moment(passDate).format('YYYY-MM-DD')
            let today = moment(date).format('YYYY-MM-DD')
            return date1 <= today ? true : false
        },
        getRemoveId(id){
            this.remove_id = id;
            $('#removeconfirm').modal('show')
        },
        selectItem(item){
            $('#appointmentcreate').modal('show')
            this.new_appointment.preid = item.preid

        },
        addLabo(){
            this.new_appointment.type = 'labo'
            console.log('Labo form')

            $('#addnew').modal('show')
        },
        addPres(){
            this.new_appointment.type = 'prescription'
            console.log('Pres form')

            $('#addnew').modal('show')
        },
        async createAppoint(){


            await axios.post('api/v1/prescription/addnewAppoint/'+this.new_appointment.preid,this.new_appointment)
                        .then(res => {
                            if(res.data.data.type === 'prescription'){
                                this.$router.push({name: 'prescription', query:{ preId: res.data.data.preid }})
                            }
                            if(res.data.data.type === 'labo'){
                                this.$router.push({ name: "Laboratory", query: { preId:  res.data.data.preid} });
                            }
                        })
        },
        async  removeAppoint(){
            await  axios.post('api/v1/prescription/removeAppoint/'+this.remove_id,this.updateBy)
                    .then(res => {
                    this.message = "Remove successfully"
                    this.messagebox()
                    this.getview()
                    })
        },
        getview(page = 1) {
            this.$router.push({name: 'Appointment', query: {page : page}})
            axios.post("/api/v1/prescription/getAllAppointment?page=" + page,this.pre_search)
                .then((response) => {
                    this.getpres = response.data.data;
                    this.total = this.getpres.length;
                    this.print = response.data.print
                });
        },
        messagebox() {
            var modal = document.getElementById("myModal");
            modal.style.display = "block";
            setTimeout(() => (modal.style.display = "none"), 2000);
        },
        formatdatetime(dateform) {
            try {
                return moment(dateform).format('DD-MM-YYYY');
            } catch (error) {
                return dateform;
            }
        },
        getcompany() {
            axios.get("/api/v1/getSetup/")
                .then((response) => {
                    this.company = response.data;
                    this.dateformart = moment(new Date()).format('DD-MM-YYYY');
                });
        },
        clearText(text) {
            if (text == 'name') {
                this.pre_search = {
                    name: this.pre_search.name,
                    startDate: '',
                    endDate: '',
                    type: ''
                }
            }
            else if (text == 'date') {
                this.pre_search = {
                    name: '',
                    startDate: this.pre_search.startDate,
                    endDate: this.pre_search.endDate,
                    type: ''
                }
            }
            else {
                this.pre_search = {
                    name: '',
                    startDate: '',
                    endDate: '',
                    type: this.pre_search.type
                }
            }
        },
        getDefault() {
            if (this.pre_search.name == '') {
                this.getview()
            }
        },
        BackToHistory (){
            history.back()
        }
    }
};
</script>
